(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('angular2-uuid')) :
    typeof define === 'function' && define.amd ? define('ng2-simple-mq', ['exports', '@angular/core', 'rxjs', 'angular2-uuid'], factory) :
    (global = global || self, factory(global['ng2-simple-mq'] = {}, global.ng.core, global.rxjs, global.angular2Uuid));
}(this, function (exports, core, rxjs, angular2Uuid) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function MQ() { }
    /**
     * @record
     */
    function SubscriptionList() { }
    var SimpleMQ = /** @class */ (function () {
        function SimpleMQ() {
            this.mq = {};
            this.subscription = {};
        }
        /**
         * @return {?}
         */
        SimpleMQ.prototype.getQueue = /**
         * @return {?}
         */
        function () {
            return Object.keys(this.mq);
        };
        /**
         * @return {?}
         */
        SimpleMQ.prototype.getSubscription = /**
         * @return {?}
         */
        function () {
            return Object.keys(this.subscription);
        };
        /**
         * @param {?} name
         * @return {?}
         */
        SimpleMQ.prototype.newQueue = /**
         * @param {?} name
         * @return {?}
         */
        function (name) {
            if (name === undefined || this.mq[name]) {
                return false;
            }
            /** @type {?} */
            var s = new rxjs.Subject();
            /** @type {?} */
            var o = s.asObservable();
            this.mq[name] = { subject: s, observable: o };
            return true;
        };
        /**
         * @param {?} name
         * @return {?}
         */
        SimpleMQ.prototype.delQueue = /**
         * @param {?} name
         * @return {?}
         */
        function (name) {
            var _this = this;
            if (name === undefined || !this.mq[name]) {
                return false;
            }
            /** @type {?} */
            var s = this.getSubscription();
            // unsubscribe all subscription for queue 'name'
            s.forEach((/**
             * @param {?} i
             * @return {?}
             */
            function (i) {
                if (_this.subscription[i].name === name) {
                    _this.unsubscribe(i);
                }
            }));
            // delete queue 'name' subject and observable
            delete this.mq[name].observable;
            delete this.mq[name].subject;
            delete this.mq[name];
        };
        /**
         * @param {?} name
         * @param {?} msg
         * @param {?=} lazy
         * @return {?}
         */
        SimpleMQ.prototype.publish = /**
         * @param {?} name
         * @param {?} msg
         * @param {?=} lazy
         * @return {?}
         */
        function (name, msg, lazy) {
            if (lazy === void 0) { lazy = true; }
            if (msg === undefined || name === undefined) {
                return false;
            }
            if (lazy) {
                this.newQueue(name);
            }
            else if (!this.mq[name]) {
                return false;
            }
            this.mq[name].subject.next(msg);
            return true;
        };
        /**
         * @param {?} name
         * @param {?} callback
         * @param {?=} lazy
         * @return {?}
         */
        SimpleMQ.prototype.subscribe = /**
         * @param {?} name
         * @param {?} callback
         * @param {?=} lazy
         * @return {?}
         */
        function (name, callback, lazy) {
            if (lazy === void 0) { lazy = true; }
            if (name === undefined || callback === undefined) {
                return '';
            }
            if (lazy) {
                this.newQueue(name);
            }
            else if (!this.mq[name]) {
                return '';
            }
            /** @type {?} */
            var id = name + '-' + angular2Uuid.UUID.UUID();
            this.subscription[id] = {
                name: name,
                subscription: this.mq[name].observable.subscribe(callback)
            };
            return id;
        };
        /**
         * @param {?} id
         * @return {?}
         */
        SimpleMQ.prototype.unsubscribe = /**
         * @param {?} id
         * @return {?}
         */
        function (id) {
            if (id === undefined || !this.subscription[id]) {
                return false;
            }
            this.subscription[id].subscription.unsubscribe();
            delete this.subscription[id];
        };
        SimpleMQ.decorators = [
            { type: core.Injectable }
        ];
        return SimpleMQ;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        SimpleMQ.prototype.mq;
        /**
         * @type {?}
         * @private
         */
        SimpleMQ.prototype.subscription;
    }

    exports.SimpleMQ = SimpleMQ;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ng2-simple-mq.umd.js.map
